unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class (TForm)
    Button1: TButton;
    Memo1:   TMemo;
    procedure Button1Click (Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses xtea3;

{$R *.dfm}


var
  buf: t128buf = (0, 0, 0, 0);

var
  cb: t128buf;

var
  tkey: array [0..7] of longword;

const
  test_count = 100;

procedure TForm1.Button1Click (Sender: TObject);
var
  i: integer;
  error: boolean;
begin

  error := False;

  randomize();

  for i := 0 to test_count - 1 do
    begin

    buf[0] := random(maxlong);
    buf[1] := random(maxlong);
    buf[2] := random(maxlong);
    buf[3] := random(maxlong);


    tkey[0] := random(maxlong);
    tkey[1] := random(maxlong);
    tkey[2] := random(maxlong);
    tkey[3] := random(maxlong);
    tkey[4] := random(maxlong);
    tkey[5] := random(maxlong);
    tkey[6] := random(maxlong);
    tkey[7] := random(maxlong);


    xtea3_setkey(@tkey);   // Loading then key

    memo1.Lines.Add(#13#10#13#10 + 'KEY: ');
    memo1.Lines.Add(Format('%8x %8x %8x %8x %8x %8x %8x %8x ',
      [key[0], key[1], key[2], key[3], key[4], key[5], key[6], key[7]]));

    memo1.Lines.Add('ORIGINAL: ');
    memo1.Lines.Add(Format('%8x %8x %8x %8x', [buf[0], buf[1], buf[2], buf[3]]));

    move(buf, cb, 16);
    xtea3_crypt(@cb); // Encryption of 2-longwords (64 bit block)

    memo1.Lines.Add('ENCRYPTED: ');
    memo1.Lines.Add(Format('%8x %8x %8x %8x ', [cb[0], cb[1], cb[2], cb[3]]));


    xtea3_setkey(@tkey);   // Loading then key

    xtea3_decrypt(@cb); // Decryption of 2-longwords (64 bit block)

    memo1.Lines.Add('DECRYPTED: ');
    memo1.Lines.Add(Format('%8x %8x %8x %8x ', [cb[0], cb[1], cb[2], cb[3]]));

    if (cb[0] <> buf[0]) or (cb[1] <> buf[1]) or (cb[2] <> buf[2]) or
      (cb[3] <> buf[3]) then
      error := True;

    if error then
      memo1.Lines.Add('DECODED TO BAD DATA!!!')
    else

      memo1.Lines.Add('DECODED OK');

    end;


  memo1.Lines.Add(#13#10#13#10#13#10 + ' ------------------------------  ');

  if error then
    memo1.Lines.Add('TEST FAILED, DECODED DATA IS BAD.')
  else
    memo1.Lines.Add(FORMAT('ALL %U TESTS FINISHED OK!', [test_count]));

end;

end.
